﻿Imports Data_Points_0917_EFCore2Model.JimmyBogardRocks
'source: http://grabbagoft.blogspot.com/2007/06/generic-value-object-equality.html

Namespace SamuraiApp.Domain
    Public Class PersonFullName
        Inherits ValueObject(Of PersonFullName)

        Public Shared Function Create(ByVal first As String, ByVal last As String) As PersonFullName
            Return New PersonFullName(first, last)
        End Function
        Public Shared Function Empty() As PersonFullName
            Return New PersonFullName(Nothing, Nothing)
        End Function

        Public Function IsEmpty() As Boolean
            If String.IsNullOrEmpty(First) AndAlso String.IsNullOrEmpty(Last) Then
                Return True
            Else
                Return False
            End If
        End Function
        Private Sub New(ByVal first As String, ByVal last As String)
            Me.First = first
            Me.Last = last
        End Sub

        Private privateFirst As String
        Public Property First As String
            Get
                Return privateFirst
            End Get
            Private Set(ByVal value As String)
                privateFirst = value
            End Set
        End Property
        Private privateLast As String
        Public Property Last As String
            Get
                Return privateLast
            End Get
            Private Set(ByVal value As String)
                privateLast = value
            End Set
        End Property
        Public FullName As String = First & " " & Last

    End Class
End Namespace