﻿Imports System
Imports System.Collections.Generic
Imports System.Linq

Namespace SamuraiApp.Domain
  Public Class Samurai


	Public Sub New(ByVal name As String)
		Me.New()
	  Me.Name = name
            GuidId = Guid.NewGuid
            IsDirty =True
	End Sub
	Private Sub New()
            _quotes = New List(Of Quote)
            SecretIdentity = PersonFullName.Empty
        End Sub
	Private privateId As Integer
        Public Property Id As Integer
            Get
                Return privateId
            End Get
            Private Set(ByVal value As Integer)
                privateId = value
            End Set
        End Property
        Private privateGuidId As Guid
        Public Property GuidId As Guid
            Get
                Return privateGuidId
            End Get
            Private Set(ByVal value As Guid)
                privateGuidId = value
            End Set
        End Property
        Private privateName As String
        Public Property Name As String
            Get
                Return privateName
            End Get
            Private Set(ByVal value As String)
                privateName = value
            End Set
        End Property
        Private privateIsDirty As Boolean
        Public Property IsDirty As Boolean
            Get
                Return privateIsDirty
            End Get
            Private Set(ByVal value As Boolean)
                privateIsDirty = value
            End Set
        End Property
#Region "demonstrates fully encapsulated collection"
        Private ReadOnly _quotes As New List(Of Quote)

        Public Quotes As IEnumerableFunction = _quotes.ToList

        Public Sub AddQuote(ByVal quoteText As String)
	  _quotes.Add (New Quote(GuidId,quoteText))
	  IsDirty=True
	End Sub

#End Region
	#Region "demonstrates private 1:1 prop with backing field, note mapping in context file"
	Private _entrance As Entrance
        Private ReadOnly Property Entrance As Entrance
            Get
                Return _entrance
            End Get
        End Property
        Public Sub CreateEntrance(ByVal minute As Integer, ByVal sceneName As String, ByVal description As String)
	  _entrance = New Entrance(GuidId, minute, sceneName, description)
	  IsDirty=True
	End Sub
        Public EntranceScene As String = _entrance?.SceneName
#End Region

#Region "demonstrates private value object with public methods to control how values are set and accessed"
        Private Property SecretIdentity As PersonFullName
        Public Property SamuraiSecretIdentity As Object

        Public Function RevealSecretIdentity() As String
            If SecretIdentity.IsEmpty Then
                Return "It's a secret"
            Else
                Return SamuraiSecretIdentity.FullName
            End If
        End Function
        Public Sub Identify(ByVal first As String, ByVal last As String)
	  SecretIdentity = PersonFullName.Create(first, last)
	  IsDirty=True
	End Sub
	#End Region
  End Class
End Namespace