﻿Imports System
Imports System.Linq
Imports System.Reflection
Imports Microsoft.EntityFrameworkCore
Imports Data_Points_0917_EFCore2Model.SamuraiApp.Data
Imports Data_Points_0917_EFCore2Model.SamuraiApp.Domain

Namespace Data_Points_0917_EFCore2Model
  Friend Class Program
	Shared Sub Main(ByVal args() As String)
            Using context = New SamuraiContext
                context.Database.EnsureDeleted()
                context.Database.EnsureCreated()
            End Using
            StoreNewSamuraiWithNoEntrance()
	  StoreNewSamuraiWithEntrance()
	  StoreNewSamuraiWithEntranceAndIdentity()
	  ListSamuraisWithEntranceAndIdentity()

	End Sub
	 Private Shared Sub StoreNewSamuraiWithNoEntrance()
	  Dim samurai = New Samurai("InvisibleMan")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub
	Private Shared Sub StoreNewSamuraiWithEntrance()
	  Dim samurai = New Samurai("Julie")
	  samurai.CreateEntrance(1, "S1", "Tumbles off a roof")
	  samurai.AddQuote("Ouch!")
	  samurai.AddQuote("That hurt!")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub

	Private Shared Sub StoreNewSamuraiWithEntranceAndIdentity()
	  Dim samurai = New Samurai("Giantpuppy")
	  samurai.Identify("Sampson", "Newfie")
	  samurai.CreateEntrance(2, "S2", "Walks in on all fours")
            Using context = New SamuraiContext
                context.Samurais.Add(samurai)
                context.SaveChanges()
            End Using
        End Sub
	Private Shared Sub ListSamuraisWithEntranceAndIdentity()
            Using context = New SamuraiContext
                Dim samurais = context.Samurais.Include("Entrance").ToList()
                For Each samurai In samurais
                    Console.WriteLine($"{samurai.Name}, Enters in {samurai.EntranceScene} ")
                    Dim bindFlags As BindingFlags = BindingFlags.Instance OrElse BindingFlags.Public OrElse BindingFlags.NonPublic OrElse BindingFlags.Static

                    Dim entrancePropInfo = samurai.GetType.GetField("_entrance", bindFlags)
                    Dim entranceObject = entrancePropInfo.GetValue(samurai)
                    Dim guidValue = entranceObject?.GetType().GetProperty("SamuraiGuidId").GetValue(entranceObject)
                    Console.WriteLine($"SamuraiGuid: {samurai.GuidId}, E.SG: {guidValue}")
                    Console.WriteLine($"Secret Identity: {samurai.RevealSecretIdentity()}")
                Next samurai
            End Using
        End Sub

  End Class
End Namespace